function [x,y]=FaceDetection( x, y, Scale, IntegralImages, w,h,TrainDetector)

InverseArea = 1 / (w*h);
mean =  SumRect(IntegralImages.ii,x,y,w,h)*InverseArea;
Variance = SumRect(IntegralImages.iistd,x,y,w,h)*InverseArea - (mean.^2);
Variance(Variance<1)=1; StandardDeviation =sqrt(Variance);

% go through all classifiers 
for index_stage = 1:length(TrainDetector.stages),
    stage = TrainDetector.stages(index_stage);
    Trees=stage.trees;
    StageSum = zeros(size(x));
    
    % go through a classifier tree
    for index_tree=1:length(Trees)
        Tree = Trees(index_tree).value;
        % get decision form a classifier
        TreeSum=TreeDecision(zeros(size(x)),Tree,Scale,x,y,IntegralImages.ii,StandardDeviation,InverseArea);
        StageSum = StageSum + TreeSum;
    end
    % If the StageSum of a coordinate is larger than threshold, it is kept and goes to next iteration
    decision=StageSum < stage.stage_threshold;
    
    % Remove false coordinates that don't have face there
    x=x(~decision);  
    if(isempty(x))
        break; 
    end                                    
    y=y(~decision);
    StandardDeviation=StandardDeviation(~decision);
%     if(size(x,1)<=1)
%         break;
%     end
end


