function IntegralImages = IntergralImages(img,Options)
% calculate integral image 
img=im2double(img);

% Resize the image 
if(Options.Resize)
    if (size(img,2) > size(img,1)),
        Ratio = size(img,2) / 384;
    else
        Ratio = size(img,1) / 384;
    end
    img = imresize(img, [size(img,1) size(img,2) ]/ Ratio);
else
    Ratio=1;
end


% calculate the integral image 
IntegralImages.ii=cumsum(cumsum(img,1),2);
IntegralImages.ii=padarray(IntegralImages.ii,[1 1], 0, 'pre');

% integral image based on standard deviation 
IntegralImages.iistd=cumsum(cumsum(img.^2,1),2);
IntegralImages.iistd=padarray(IntegralImages.iistd,[1 1], 0, 'pre');

IntegralImages.width = size(img,2);
IntegralImages.height = size(img,1);
IntegralImages.Ratio=Ratio;
